from collections import deque, defaultdict

# Чтение входных данных
n, m, k = map(int, input().split())
graph = defaultdict(list)

# Построение графа
for _ in range(m):
    a, b = map(int, input().split())
    graph[a].append(b)
    graph[b].append(a)

# Список охранников и их выносливость
guards = []
for _ in range(k):
    p, h = map(int, input().split())
    guards.append((p, h))

# Множество для хранения охраняемых складов
protected = set()

# Обработка каждого охранника
for p, h in guards:
    # BFS для поиска охраняемых складов
    queue = deque([(p, 0)])  # (текущий склад, расстояние)
    visited = set()

    while queue:
        current, dist = queue.popleft()

        if dist > h:
            break  # выносливость исчерпана

        if current not in visited:
            visited.add(current)
            protected.add(current)  # добавление охраняемого склада

            for neighbor in graph[current]:
                if neighbor not in visited:
                    queue.append((neighbor, dist + 1))

# Вывод результата
protected = sorted(protected)
print(len(protected))
print(" ".join(map(str, protected)))
